package jp.topse.kaizu.sequence2csp;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.Namespace;

public class XmiReader {
	public EObject read(IFile file) throws IOException {
		URI uri = URI.createPlatformResourceURI(
				file.getFullPath().toOSString(), true);
		ResourceSet resourceSet = new ResourceSetImpl();
		Resource resource = resourceSet.getResource(uri, true);
		resource.load(null);
		EObject eObject = (EObject) (resource.getContents().get(0));
		return eObject;
	}

	public static List<Interaction> collectInteraction(EObject eObject) {
		List<Interaction> interactions = new ArrayList<Interaction>();
		for (Object child : eObject.eContents()) {
			if (child instanceof Interaction) {
				interactions.add((Interaction) child);
			} else if (child instanceof Namespace) {
				interactions.addAll(collectInteraction((Namespace) child));
			}
		}
		return interactions;
	}
}
