package jp.topse.kaizu.sequence2csp.action;

import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import jp.topse.kaizu.sequence2csp.XmiReader;
import jp.topse.kaizu.sequence2csp.convert.Converter;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.uml2.uml.Interaction;

public class ConvertAction implements IObjectActionDelegate {
	private List<IFile> files;

	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	public void run(IAction action) {
		FileWriter fw = null;
		try {
			XmiReader xmiReader = new XmiReader();
			for (IFile file : files) {
				EObject model = xmiReader.read(file);
				Converter converter = new Converter();
				List<Interaction> interactions = XmiReader
						.collectInteraction(model);

				String csp = converter.convert(interactions);
				IFile out = file.getParent().getFile(
						new Path(file.getName() + ".fdr2"));
				String osstring = out.getRawLocation().toOSString();
				fw = new FileWriter(osstring);
				fw.write(csp);
				fw.close();
				out.refreshLocal(IFile.DEPTH_INFINITE, null);
			}
		} catch (IOException ex) {
			MessageDialog.openError(null, "CSP Converter", ex
					.getLocalizedMessage());
		} catch (CoreException ex) {
			MessageDialog.openError(null, "CSP Converter", ex
					.getLocalizedMessage());
		} finally {
			if (fw != null) {
				try {
					fw.close();
				} catch (IOException ex) {
					MessageDialog.openError(null, "CSP Converter", ex
							.getLocalizedMessage());
				}
			}
		}
	}

	public void selectionChanged(IAction action, ISelection selection) {
		files = new ArrayList<IFile>();
		if (selection instanceof IStructuredSelection) {
			IStructuredSelection structured = (IStructuredSelection) selection;
			Iterator<?> it = structured.iterator();
			while (it.hasNext()) {
				Object obj = it.next();
				if (obj instanceof IFile) {
					files.add((IFile) obj);
				}
			}
		}

	}
}
