package jp.topse.kaizu.sequence2csp.convert;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;
import java.util.regex.Pattern;

import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.Lifeline;

public class Util {
	public static final String LINE_SEPARATOR = System
			.getProperty("line.separator");

	/**
	 * A
	 * 
	 * @param strings
	 * @param separator
	 * @return
	 */
	public static String join(Collection<String> strings, String separator) {
		StringBuilder sb = new StringBuilder();
		boolean needSeparator = false;
		for (String str : strings) {
			if (needSeparator) {
				sb.append(separator);
			} else {
				needSeparator = true;
			}
			sb.append(str);
		}
		return sb.toString();
	}

	/**
	 * A
	 * 
	 * @param first
	 * @param strings
	 * @param separator
	 * @return
	 */
	public static String join(String first, Collection<String> strings,
			String separator) {
		StringBuilder sb = new StringBuilder(first);
		for (String str : strings) {
			sb.append(separator);
			sb.append(str);
		}
		return sb.toString();
	}

	public static Set<String> removeAll(Set<String> set1, Set<String> set2) {
		Set<String> set = new HashSet<String>();
		set.addAll(set1);
		set.removeAll(set2);
		return set;
	}

	public static Set<String> select(Set<String> set1, Pattern pattern) {
		Set<String> set = new HashSet<String>();
		for(String str : set1){
			if(pattern.matcher(str).matches()){
				set.add(str);
			}
		}
		return set;
	}
	
	public static boolean isActor(Lifeline lifeline){
		return (lifeline.getRepresents().getType() instanceof Actor);
	}
}
